const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Audit_logsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const audit_logs = await db.audit_logs.create(
      {
        id: data.id || undefined,

        actor: data.actor || null,
        action: data.action || null,
        object_type: data.object_type || null,
        object_id: data.object_id || null,
        timestamp: data.timestamp || null,
        diff: data.diff || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await audit_logs.setOrganizations(data.organizations || null, {
      transaction,
    });

    return audit_logs;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const audit_logsData = data.map((item, index) => ({
      id: item.id || undefined,

      actor: item.actor || null,
      action: item.action || null,
      object_type: item.object_type || null,
      object_id: item.object_id || null,
      timestamp: item.timestamp || null,
      diff: item.diff || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const audit_logs = await db.audit_logs.bulkCreate(audit_logsData, {
      transaction,
    });

    // For each item created, replace relation files

    return audit_logs;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const audit_logs = await db.audit_logs.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.actor !== undefined) updatePayload.actor = data.actor;

    if (data.action !== undefined) updatePayload.action = data.action;

    if (data.object_type !== undefined)
      updatePayload.object_type = data.object_type;

    if (data.object_id !== undefined) updatePayload.object_id = data.object_id;

    if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;

    if (data.diff !== undefined) updatePayload.diff = data.diff;

    updatePayload.updatedById = currentUser.id;

    await audit_logs.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await audit_logs.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return audit_logs;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const audit_logs = await db.audit_logs.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of audit_logs) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of audit_logs) {
        await record.destroy({ transaction });
      }
    });

    return audit_logs;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const audit_logs = await db.audit_logs.findByPk(id, options);

    await audit_logs.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await audit_logs.destroy({
      transaction,
    });

    return audit_logs;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const audit_logs = await db.audit_logs.findOne({ where }, { transaction });

    if (!audit_logs) {
      return audit_logs;
    }

    const output = audit_logs.get({ plain: true });

    output.organizations = await audit_logs.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.actor) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('audit_logs', 'actor', filter.actor),
        };
      }

      if (filter.action) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('audit_logs', 'action', filter.action),
        };
      }

      if (filter.object_type) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'audit_logs',
            'object_type',
            filter.object_type,
          ),
        };
      }

      if (filter.diff) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('audit_logs', 'diff', filter.diff),
        };
      }

      if (filter.object_idRange) {
        const [start, end] = filter.object_idRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            object_id: {
              ...where.object_id,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            object_id: {
              ...where.object_id,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.timestampRange) {
        const [start, end] = filter.timestampRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.audit_logs.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('audit_logs', 'actor', query),
        ],
      };
    }

    const records = await db.audit_logs.findAll({
      attributes: ['id', 'actor'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['actor', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.actor,
    }));
  }
};
